/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: adpcm.h
* ߲		: IAR EWAAVR 3.10C
* 			: $Revision: 1.4 $
* t			: $Date: Monday, November 15, 2004 12:53:58 UTC $
* XV		: $Author: raapeland $
*
* xҰ		: avr@atmel.com
*
* x޲	: ̗ATmega128pɏĂ܂B̧ѳ͍Œ4K޲(+
*				  ްp̏[ȋ)ׯ ؂ǂꂩAVRź߲ق
*				  ׂłB
*
* pLq		: AVR336: ADPCM
*
* 			: ADPCMͯ ̧فA\̒`Ɗ֐^̐錾Aޯ ق
*				  `Ȃ
*
****************************************************************************/

#include "ioavr.h"

/*
 * ADPCMԍ\
 */

typedef struct adpcm_state_ {
	long yl;		// Œ艻(ᑬ)ԎړxWiKʏ搔
	short yu;		// Œ艻()ԎړxWiKʏ搔
	short dms;		// ZԴٷް\
	short dml;		// Դٷް\
	short ap;		// 'yl''yu'̒d݌W

	short a[2];		// \hg̋ɕ
	short b[6];		// \hg̗_
	short pk[2];	// O̕Iȍč\M̕

	short dq[6];	// ʎqꂽM̒O̎
	short sr[2];	// č\ꂽM̒O̎
	char td;		// owq
} *adpcm_state;

/*
 * ֐^錾
 */

int scale_factor_adapt(adpcm_state state);
extern long update_yl(long yl, int yu); 
int decode(char i, adpcm_state state);
short predictor(short *sez, adpcm_state state);
void adaptation_speed_control(int fi, int tr, int y, adpcm_state state);
char transition_detection(short dql, adpcm_state state);
int antilog(int sign, int dql);
short update_pred_coeff(int	dq,
						int	sr,
						int	dqsez,
						char    tr,
						char    pk0,
						adpcm_state state);
void initialize_adpcm(adpcm_state state);
unsigned char get_code(void);
void initialize_pwm(void);

#pragma vector = TIMER3_COMPA_vect
__interrupt void TIMER3_COMPA(void);

/*
 * `(ޯ , PWM`ԂȂ)
 */

#define INPUTSIZE	58335	// ^̗e
#define END_OF_DATA	100		// ްget_code()ɂĕԂl
#define BITS		5		// ޯĐ(2,3,4܂5)
#define BUFFER_SIZE	128		// o͊ɏՕe(wWϐ'char'^̂߁Aő255)
