/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: c-izer.c
* ߲		: Dev-Cpp 4.9.9.0߲
*				  (http://www.bloodshed.net/devcpp.html) 
* 			: $Revision: 1.2 $
* t			: $Date: Monday, November 15, 2004 12:26:52 UTC $
* XV		: $Author: raapeland $
*
* xҰ		: avr@atmel.com
*
* pLq		: AVR336: ADPCM
*
* 			: ڲݸٰނ邽߂ɕ(ENCODE)°ق̕o͂CzK
*				  ɕύX邽߂̊ȒPȉp
*
****************************************************************************/
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <iomanip>
#include <exception>

using namespace std;

typedef vector<int> intVector;		// Ȃ޸pɎyȌ^錾

// ̊֐ENCODE°قɂč쐬ꂽ̧قǂް ޸ɉ͂
// SĂ޲Ău܂B
void read_file( string filename, intVector & data )
{
	ifstream f( filename.c_str() );						// َ̧gpJn錾
	string theText;

	f >> theText;										// vf\ߓǂݍ
	while( !f.eof() ) {									// ̧ق̍ŌɒB܂Ōp
		istringstream iss( theText.substr( 2, 2 ) );	// '0x'','𔍂
		int theByte;
		iss >> hex >> theByte;							// 16i𐮐ɕϊ
		data.push_back( theByte );						// ް ޸i[
		f >> theText;									// ̕vfǂݍ
	}
}

// ̊֐ް ޸̓e̺߲ד#pragma[߂ƋCz
// Č`ꂽ̧قɏ܂B
void write_file( string filename, intVector & data )
{
	ofstream f( filename.c_str() );						// َ̧gpJn錾
	f.fill( '0' );										// (Ⴆ'0x 5'̑'0x05'𓾂܂B)

	// Ȑ擪
	f << "/* Array size: " << data.size() << " bytes. */" << endl;
	f << "#pragma memory = __hugeflash" << endl;
	f << "char packed_ [] = {" << endl;

	// zɑS޲ď
	for( int i = 0; i < data.size(); i++ ) {
		f << "0x" << hex << setw(2) << data[i];
		if( i != data.size()-1 ) f << ",";				// ŏIȊȎS޲Ă','t
		f << " ";										// s' 't
		if( i % 8 == 7 ) f << endl;						// 8޲Ėɉst
	}

	// ȍŏI
	f << "};" << endl;
	f << "#pragma memory = default" << endl;
	f << "char __hugeflash *packed = packed_;" << endl;
}

int main(int argc, char *argv[])
{
	// Ɍ
	if( argc != 3 ) {
		cerr << "Syntax: c-izer [infile] [outfile]" << endl;
		return -1;
	}

	// ̧ٖް ޸̏
	string infile( argv[1] );
	string outfile( argv[2] );
	intVector theData;

	try {
		read_file( infile, theData );		// ޸ްǂݍ
		write_file( outfile, theData );		// Cz̧قɏo
	} catch( exception & e ) {
		cerr << "An exception occured: " << e.what() << endl;
		return -1;
	}

	// gp҂ւ̗eʏo
	cout << "Size: " << theData.size() << " bytes." << endl;
}
